#immediately run this on players who join the world
execute as @a unless entity @s[scores={join=100}] run function sprint_racer:join
execute as @a[scores={hpSet=..999}] run function sprint_racer:hp_scoreboard_fix
scoreboard players add @e[name=w] join 1
execute if entity @e[name=w,scores={join=1000..}] run function sprint_racer:join_objective_refresh

#AFK check, if a player does not move for too long they become a spectator
scoreboard players add @a[tag=playing,gamemode=adventure,scores={moveState=..0},nbt={OnGround:1b}] afkTime 1
execute if entity @e[name=w,tag=halftick] run scoreboard players add @a[tag=playing,gamemode=adventure,scores={moveState=..0},nbt={OnGround:1b}] afkTime 1
scoreboard players set @a[tag=playing,scores={moveState=1..}] afkTime 0
scoreboard players set @a[tag=playing,scores={carrotInput=..9}] afkTime 0
execute as @a[tag=playing,tag=!afk,scores={afkTime=601..}] run function sprint_racer:go_afk

#this lets us lump players and AI together for some shared functionalities...
tag @e[tag=activeplayer] remove activeplayer
tag @a[tag=playing,gamemode=adventure,scores={hp=1..}] add activeplayer
tag @e[tag=ai] add activeplayer

#delayed particle thing
execute as @e[tag=delayTP] at @s run function sprint_racer:delayed_tp_particle

#inventory check cycle
execute as @a[gamemode=adventure] run function sprint_racer:inventory_check/_index

#oTimerGlobal, helps run commands at half frequency when I want to
scoreboard players add @e[name=w] oTimerGlobal 1
scoreboard players set @e[name=w,scores={oTimerGlobal=2..}] oTimerGlobal 0

#attackedID stuff for giving KO points, resets after a while
execute as @a[scores={hitPlayer=1..}] at @s run function sprint_racer:hit_another_player
scoreboard players remove @e[tag=activeplayer,scores={attackTime=1..,hitstun=..0}] attackTime 1
scoreboard players set @e[scores={attackTime=..0,attackerID=1..}] attackerID 0
#DEBUG -- execute as @a run tellraw @s ["",{"text":"attackerID = "},{"score":{"name":"@s","objective":"attackerID"}}]

#make sure speedometer get placed in the right slot if its active
execute as @a[tag=spdbump] run function sprint_racer:speedometer/speedo_bump

#level editor tag cleanup
tag @a[sort=random,gamemode=creative,limit=1,scores={playerState=2}] remove executor

#carrot on a stick
execute as @a at @s run function sprint_racer:carrot_on_stick

######################################################
#DEVELOPER STUFF
#remove comment marks to re-activate

#light update gun
#execute as @e[tag=lightgun] at @s run function sprint_racer:temp_light_gun_operate
#execute as @a[scores={carrotInput=..999,inputCooldown=..0},nbt={SelectedItem:{id:"minecraft:prismarine_shard"}}] at @s run function sprint_racer:temp_light_update_gun
#execute as @e[tag=updateblock,scores={lifespan=19}] at @s run setblock ~ ~ ~ prismarine
#execute as @e[tag=updateblock,scores={lifespan=3}] at @s run setblock ~ ~ ~ air

#convert armor stands to area effect clouds ALL the time, not just in level editor mode
#execute as @e[tag=node,type=armor_stand] at @s run function sprint_racer:game_logic/2/convert_armor_stand_to_aec/_index

#display something forever always
#scoreboard objectives setdisplay sidebar lap

#scoreboard players set @a afkTime 0
#scoreboard players set @e[scores={speedlevel=..99}] speedBoost 35
#effect give @a[scores={rot_pitch=90}] instant_damage 1 0 true
######################################################

#AI
execute unless entity @a[gamemode=creative,scores={playerState=2}] run function sprint_racer:ai/general/__ai_main

#in case multiple players are in edit mode at the same time...
#only ONE of them will carry out important node summoning commands
tag @a[limit=1,sort=random] add executor

#players in creative mode get admin controls
execute unless entity @e[name=w,tag=realms] as @a[gamemode=creative,tag=!restricted] at @s run function sprint_racer:admin

#get coordinates
execute as @a at @s run function sprint_racer:coordinates

#items
function sprint_racer:items/item_tick/_main

#movement speed and damage logic
execute as @a[gamemode=!spectator] at @s run function sprint_racer:movespeed
execute as @e[scores={damage=1..}] at @s run function sprint_racer:damage_logic/damage_slowdown
execute as @a[gamemode=!spectator,gamemode=!creative,nbt={OnGround:1b},scores={moveState=3}] at @s run function sprint_racer:sneak_regen
execute if entity @e[name=w,tag=halftick] as @a[gamemode=!spectator,gamemode=!creative,nbt={OnGround:1b},scores={moveState=3}] at @s run function sprint_racer:sneak_regen
scoreboard players set @a[scores={regenTimer=1..,moveState=..2}] regenTimer 0
execute if entity @e[name=w,scores={gameState=1}] run bossbar set minecraft:control_holdtosprint players @a[tag=playing,gamemode=!spectator,scores={timeWalked=50..}]

#count active players, show speedometer if no other players are present
scoreboard players set @e[name=w] playerCount 0
scoreboard players set @e[name=w] playerCountB 0
execute as @a[tag=playing] run scoreboard players add @e[name=w] playerCount 1
execute as @a[tag=playing,gamemode=!spectator] run scoreboard players add @e[name=w] playerCountB 1


#show speedometer if only one racer is present
execute if entity @e[name=w,tag=speedo,tag=!nospeedo] as @a[limit=1,tag=playing] at @s run function sprint_racer:speedometer/speedo_main

#xp-bar speedometer
function sprint_racer:speedometer/xp_bar_main


#potion effects
function sprint_racer:effects/passive

#GAME LOGIC
#gameState=0 means in the lobby
#gameState=1 means racing mode
#2 is reserved for players in editor mode
#gameState=3 means battle mode
#playerState=2 means using editor tools (admin)
execute as @e[limit=1,name=w,scores={gameState=0}] at @s run function sprint_racer:game_logic/0/gl0_main
execute as @e[limit=1,name=w,scores={gameState=1}] at @s run function sprint_racer:game_logic/1/gl1_main
execute as @e[limit=1,name=w,scores={gameState=3}] at @s run function sprint_racer:game_logic/3/gl3_main
execute as @e[limit=1,name=w,scores={gameState=4}] at @s run function sprint_racer:game_logic/4/gl4_main
execute as @a[scores={playerState=2}] at @s run function sprint_racer:game_logic/2/gl2_main

#teleports
execute as @e[scores={nodeState=1..},tag=node,tag=teleporter,tag=!teledest,tag=teleparticle] at @s run particle minecraft:portal ~ ~1 ~ 0 0.2 0 .5 50
execute as @e[scores={nodeState=1..},tag=node,tag=teleporter,tag=!teledest] at @s as @e[tag=activeplayer,distance=..2] run function sprint_racer:teleporter

#scoreboard cleanup
tag @e[tag=foundplayer] remove foundplayer
tag @a[tag=selecting] remove selecting
tag @a[tag=executor] remove executor
tag @a[tag=finWarn,scores={playerState=..1}] remove finWarn
tag @a[tag=finWrongWay,scores={playerState=..1}] remove finWrongWay
tag @a[tag=checkWarn,scores={playerState=..1}] remove checkWarn
tag @a[tag=checkWrongWay,scores={playerState=..1}] remove checkWrongWay
scoreboard players set @a[gamemode=adventure,scores={playerState=2}] playerState 1
scoreboard players reset @a[scores={carrotInput=..999}] carrotInput

#nodes are visualized if a player is in editor mode
execute unless entity @a[scores={playerState=2}] if entity @e[tag=node,tag=showing] as @e[tag=node,tag=showing] run function sprint_racer:node_hide
execute if entity @a[scores={playerState=2}] if entity @e[tag=node,tag=!showing] as @e[tag=node,tag=!showing] run function sprint_racer:node_show

#all entities with the floatup tag get tp'd up slowly
execute as @e[tag=floatup] at @s run tp @s ~ ~.05 ~

#all items with a lifespan score run this function and count down to death
execute as @e[scores={lifespan=..99999}] run function sprint_racer:entity_lifespan

#death logic (give KO points)
execute as @a[scores={death2=..999}] run function sprint_racer:ko_logic/_main

#input cooldown
scoreboard players remove @e[scores={inputCooldown=1..}] inputCooldown 1
execute if entity @e[name=w,tag=halftick] run scoreboard players remove @e[scores={inputCooldown=1..}] inputCooldown 1

#kill all unwanted item drops
execute as @e[type=item] unless entity @s[nbt={Item:{tag:{Tags:["stay"]}}}] if entity @s[tag=!stay] run kill @s
execute if entity @e[tag=ai] run scoreboard players add @e[type=item] itemDropAge 1
kill @e[type=experience_orb,tag=!stay]